%Check: 3.1.2022

clear;
clc;
addpath('Functions')
tic 

%outside of loops
    S=2;
    p11=1;
    p12=1-p11;
    beta=.99; 
    sigma=.2;
    
    phi{1}=1.5;
    phiy{1}=0;
    phiy{2}=0;
    phi{2}=0;  
    C1=zeros(2);
    R=zeros(2); 
    Z=[];
 
FP=[];

for kappa=.01:.002:.3
for p22=.75:.001:.999
   
    p21=1-p22;
    P=[p11 p12;p21 p22];   
 
            for j=1:S, 
                B1{j,1}=[1 sigma*(1+phi{j});...
                       -kappa/(1+beta) 1];
                
                A1{j}=[1 sigma;...
                   0 beta/(1+beta)];
                    
                B2{j}=[0 0;...
                       0 1/(1+beta)];
                  
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1;   
            end
            
    [DET,FCC,OmegaK,GammaK,FK,OtherOutput,IRS]=fmmsre(P,A,B,C,R);
    Estab1_mat=[p11*kron(OmegaK{1,1}',FK{1,1}) p12*kron(OmegaK{1,1}',FK{1,2});...
                p21*kron(OmegaK{2,1}',FK{2,1}) p22*kron(OmegaK{2,1}',FK{2,2})];
    Estab2_mat=[p11*FK{1,1} p12*FK{1,2};...
                p21*FK{2,1} p22*FK{2,2}];   %Psi_F
    IEstab=max([max(abs(eig(Estab1_mat))),max(abs(eig(Estab2_mat)))]);
    Estab=max([max(real(eig(Estab1_mat))),max(real(eig(Estab2_mat)))]);
    
   if IEstab<.9999999999999 %IE-stable REE
       k=0; 
   elseif IEstab==1 || IEstab<1
       k=1;
   else k=2;
   end
        
    FP1=max(max(abs((eye(2)-A{1,1}*(p11*OmegaK{1,1}+p12*OmegaK{2,1}))\B{1,1}-OmegaK{1,1})));
    FP2=max(max(abs((eye(2)-A{2,1}*(p21*OmegaK{1,1}+p22*OmegaK{2,1}))\B{2,1}-OmegaK{2,1})));
    FP3=max(max(abs((eye(2)-A{1,1}*(p11*OmegaK{1,1}+p12*OmegaK{2,1}))\A{1,1}-FK{1,1})));
    FP4=max(max(abs((eye(2)-A{2,1}*(p21*OmegaK{1,1}+p22*OmegaK{2,1}))\A{2,1}-FK{2,1})));
    
    
    FP=[FP; FP1 FP2 FP3 FP4];     

   Z=[Z; p22 kappa k];
    
    
   end
end
%%


count1=0;
count2=0;
for kappa=.01:.002:.3
    count1=count1+1;
p22=1;
   
    p21=1-p22;
    P=[p11 p12;p21 p22];   
 
            for j=1:S, 
                B1{j,1}=[1 sigma*(1+phi{j});...
                       -kappa/(1+beta) 1];
                
                A1{j}=[1 sigma;...
                   0 beta/(1+beta)];
                    
                B2{j}=[0 0;...
                       0 1/(1+beta)];
                  
                A{j,1}=B1{j}\A1{j}; 
                B{j,1}=B1{j}\B2{j}; 
                C{j,1}=B1{j}\C1;   
            end
            
    [DET,FCC,OmegaK,GammaK,FK,OtherOutput,IRS]=fmmsre(P,A,B,C,R);
    Estab1_mat=[p11*kron(OmegaK{1,1}',FK{1,1}) p12*kron(OmegaK{1,1}',FK{1,2});...
                p21*kron(OmegaK{2,1}',FK{2,1}) p22*kron(OmegaK{2,1}',FK{2,2})];
    Estab2_mat=[p11*FK{1,1} p12*FK{1,2};...
                p21*FK{2,1} p22*FK{2,2}];   %Psi_F
    IEstab=max([max(abs(eig(Estab1_mat))),max(abs(eig(Estab2_mat)))]);
    Estab=max([max(real(eig(Estab1_mat))),max(real(eig(Estab2_mat)))]);
    
   if IEstab<.9999999999999 %IE-stable REE
       k=0; 
   elseif IEstab==1 || IEstab<1
       k=1;
       count2=count2+1;
   else k=2;
   end
        
    FP1=max(max(abs((eye(2)-A{1,1}*(p11*OmegaK{1,1}+p12*OmegaK{2,1}))\B{1,1}-OmegaK{1,1})));
    FP2=max(max(abs((eye(2)-A{2,1}*(p21*OmegaK{1,1}+p22*OmegaK{2,1}))\B{2,1}-OmegaK{2,1})));
    FP3=max(max(abs((eye(2)-A{1,1}*(p11*OmegaK{1,1}+p12*OmegaK{2,1}))\A{1,1}-FK{1,1})));
    FP4=max(max(abs((eye(2)-A{2,1}*(p21*OmegaK{1,1}+p22*OmegaK{2,1}))\A{2,1}-FK{2,1})));
    
    
    FP=[FP; FP1 FP2 FP3 FP4];     

   Z=[Z; p22 kappa k];
    
    

end


    ZZZ=[];
    zzz=[];
    yyy=[];
for iii=1:size(Z,1)
    if Z(iii,3)==0
        ZZZ=[ZZZ;Z(iii,1:2)];  
    elseif Z(iii,3)==1
         zzz=[zzz;Z(iii,1:2)];   
    elseif Z(iii,3)==2
         yyy=[yyy;Z(iii,1:2)];   
    end
end


%%
figure(3)


%subplot(2,2,1)

scatter(ZZZ(:,1),ZZZ(:,2),1.5,'b+')
hold on
scatter(zzz(:,1),zzz(:,2),20,'r')




axis([.75 1 0 .2])
xlim([.75 1])
ylim([.01 .3])
box on
% line([0 3],[1 1],'Color','black','LineStyle','--','LineWidth',1.2);
% line([1 1],[0 1.5],'Color','black','LineStyle','--','LineWidth',1.2); 
set(gca,...
    'XTickLabel',{'0.8' '0.85' '0.9' '0.95' '1'},...
    'XTick',[.8 .85 .9 .95 1],'FontSize',14,'FontName', 'Times',...
    'YTickLabel',{ '0' '0.05' '0.1' '0.15' '0.2' '0.25' '0.3'},...
    'YTick',[0 .05 .1 .15 .2 .25 .3],'FontSize',14,'FontName', 'Times');
% set(gcf,'position',[10,10,1200,350])
xlabel('\eta','FontSize',22,'FontName', 'Times')
ylabel('\kappa','FontSize',22,'FontName', 'Times')
title('Price Level Targeting','FontSize',18,'FontName', 'Times','FontWeight','Normal')
legend('IE-stable')





